#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/wait.h>
#include <signal.h>

static void execute (char *tb[])
{
	int pid;
	int status;
	int i;
	printf ("Executing ");
	for (i=0; tb[i] != NULL; i++) printf (" %s",tb[i]);
	printf ("\n");
	pid = fork();
	if (pid == 0){
		execv (tb[0],tb);
	}
	wait (&status);
}

int main (int argc, char *argv[])
{
	FILE *fin;
	int i;
	extern char **environ;
	int fd = open ("/dev/tty1",O_RDWR);
	if (fd != -1){
		dup2 (fd,0);
		dup2 (fd,1);
		dup2 (fd,2);
	}
	for (i=0; i<argc; i++){
		printf ("argv[%d] = %s\n",i,argv[i]);
	}
	for (i=0; environ[i] != NULL; i++){
		printf ("environ[%d] = %s\n",i,environ[i]);
	}
	{
		static char *tb[]={
			"/bin/mount",
			"-t",
			"proc",
			"/dev/none",
			"/proc",
			NULL
		};
		execute (tb);
	}
	fin = fopen ("/tmp/linuxrc.liste","r");
	if (fin != NULL){
		char buf[500];
		while (fgets(buf,sizeof(buf)-1,fin)!=NULL){
			char *args[50];
			char *pt = buf;
			int no = 1;
			args[0] = "/sbin/insmod";
			while (*pt != '\0'){
				if (*pt <= ' '){
					pt++;
				}else{
					args[no++] = pt;
					while (*pt > ' ') pt++;
					if (*pt == '\0') break;
					*pt++ = '\0';
				}
			}
			if (no > 1){
				args[no] = NULL;
				execute (args);
			}
		}
	}
	{
		static char *tb[]={
			"/bin/umount",
			"/proc",
			NULL
		};
		execute (tb);
	}
	return 0;
}

