#pragma interface
#ifndef DIALOG_MSG_H
#define DIALOG_MSG_H

#ifndef MISC_H
	#include <misc.h>
#endif

/* #Specification: PRIVATE_MESSAGE / principle
	A private message is simply the address of an object. The object
	has no content, but its address is unique. In general, private messages
	are used to communicate between various threads without interference
	with other threads. Unlike textual messages, private message
	can't be wrong (spelling error) and may be used to establish
	communication between a single dialog set. Textual messages are more
	useful to send broadcast to potentially unknown participants.

	The class PRIVATE_MESSAGE could have been a void *, but we wanted
	to have something really type safe, avoiding confusion. 
*/
class PRIVATE_MESSAGE: public ARRAY_OBJ{
};
class PRIVATE_MESSAGES: public ARRAY{
	/*~PROTOBEG~ PRIVATE_MESSAGES */
public:
	PRIVATE_MESSAGE *getitem (int no)const;
	/*~PROTOEND~ PRIVATE_MESSAGES */
};

extern PRIVATE_MESSAGE dialog_controlc;


#endif
