/* The following source has been taken from the pty-redir package which
	is itself GPL, like Linuxconf. pty-redir is made of a single file
*/
/*
	Copyright (c) 1997 Magosnyi rpd

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or (at
your option) any later version.

This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Ez a program szabad szoftver; szbadon msolhat s/vagy mdosthat
a GNU General Public Licence felttelei alapjn, ahogyan azt a Szabad
Szoftver Alaptvny kzreadta; akr a 2-es, akr brmely ksbbi verzi 
alapjn.

Ezt a programot abban a remnyben terjesztem, hogy hasznlhat lesz,
de BRMILYEN GARANCIA NLKL; belertve a hasznlhatsgra vagy egy adott
clra val megfelelsre vonatkoz garancit is.
Lsd a GNU General Public Licence-t a rszletekrt.

Ezt a programot ksrnie kell a GNU General Public Licence egy
msolatnak. Ha ezt hinyoln, rjon a Free Software Foundation, Inc.,
675 Mass Ave, Cambridge, Ma 02139, USA cmre.

Ha brmi problmd, szrevteled, tleted, patched van, rj a
mag@tas.vein.hu, vagy az ssa@tohotom.vein.hu cmre (az utbbi a
Magyar Szabad Szoftver Alaptvny levelezlistja.)

*/

#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>


#define PTY00 "/dev/ptyXX"
#define PTY10 "pqrs"
#define PTY01 "0123456789abcdef"

static int
getPtyMaster(char *tty10, char *tty01)
{
    char *p10;
    char *p01;
    static char dev[] = PTY00;
    int fd;

    for (p10 = PTY10; *p10 != '\0'; p10++) {
        dev[8] = *p10;
        for (p01 = PTY01; *p01 != '\0'; p01++) {
            dev[9] = *p01;
            fd = open(dev, O_RDWR);
            if (fd >= 0) {
                *tty10 = *p10;
                *tty01 = *p01;
                return fd;
            }
        }
    }
    fprintf(stderr,"Ran out of pty.\n");
    exit(1);
    return fd;
}

int main(int argc,char *argv[])
{
	int fd;
	char a,b;
	char **args;
	char *envs[]={NULL};
	int i;
	
	fd=getPtyMaster(&a,&b);
	fprintf(stdout,"/dev/tty%c%c",a,b);
	fflush(stdout);
	if(NULL==(args=malloc((argc)*sizeof(char *))))
	{
		fprintf(stderr,"Virtual memory exhausted\n");
		exit(1);
	}
	for(i=1;i<argc;i++)
	{
		args[i-1]=argv[i];
	}
	args[argc-1]=NULL; /*End of params*/
	dup2(fd,0);
	dup2(fd,1);
	fflush(NULL);
	if(fork())
	{
		exit(0);
	}else{
		if(execve(argv[1],args,envs))
		{
			perror("execve: ");
			exit(-2);
		}
	}
	return 0;
}
