#pragma interface
// Global:
#define KEY_SET			10
#define KEY_POSTMASTER		11
#define KEY_NO_BOUNCEMAIL	12
#define KEY_LOGFILE		13
#define KEY_IDFILE		14
#define KEY_SYSLOG		15
#define KEY_NOSYSLOG		16
#define KEY_BASIC_PROPERTIES	17
#define KEY_DAEMON		18

// Server:
#define KEY_POLL		100
#define KEY_SKIP		101
#define KEY_VIA			103
#define KEY_PROTOCOL		104
#define KEY_PORT		110
#define KEY_AUTHENTICATE	112
#define KEY_TIMEOUT		114
#define KEY_ENVELOPE		120
#define KEY_QVIRTUAL		123
#define KEY_AKA			125
#define KEY_INTERFACE		130
#define KEY_MONITOR		132
#define KEY_LOCALDOMAINS	134
#define KEY_PLUGIN		140
#define KEY_PLUGOUT		142
#define KEY_DNS			144
#define KEY_CHECKALIAS		150
#define KEY_UIDL		152

// User:
#define KEY_USERNAME		200
#define KEY_THERE		201
#define KEY_IS			202
#define KEY_HERE		203
#define KEY_PASSWORD		204
#define KEY_FOLDER		206
#define KEY_SMTPHOST		210
#define KEY_SMTPADDRESS		212
#define KEY_ANTISPAM		214
#define KEY_MDA			216
#define KEY_BSMTP		220
#define KEY_PRECONNECT		222
#define KEY_POSTCONNECT		224
#define KEY_KEEP		230
#define KEY_FLUSH		232
#define KEY_FETCHALL		234
#define KEY_REWRITE		236
#define KEY_STRIPCR		238
#define KEY_FORCECR		240
#define KEY_PASS8BITS		242
#define KEY_DROPSTATUS		244
#define KEY_MIMEDECODE		246
#define KEY_LIMIT		250
#define KEY_WARNINGS		251
#define KEY_BATCHLIMIT		252
#define KEY_FETCHLIMIT		253
#define KEY_EXPUNGE		254
#define KEY_PROPERTIES		255

// Misc:
#define KEY_NO			980
#define KEY_IGNORE		990
#define KEY_UNKNOWN		999

#define WORD			100
class KEYWORD: public ARRAY_OBJ {
public:
	int id;
	bool implemented;
	bool parameter;
	bool multiparameters;
	SSTRING word;
	bool value;
private:
	void init(void);
	/*~PROTOBEG~ KEYWORD */
public:
	KEYWORD(void);
	void init( KEYWORD *keyword );
	/*~PROTOEND~ KEYWORD */
};

class KEYWORDLIST: public ARRAY {
	char *p;
private:
	char *next_word( char *d, const char *s, int size );
	/*~PROTOBEG~ KEYWORDLIST */
public:
	KEYWORDLIST(void);
	KEYWORD *getitem( const char *id ) const;
	KEYWORD *getitem( int value ) const;
	void clean_option( );
	KEYWORD *option( char *word, const char *config, int size );
	/*~PROTOEND~ KEYWORDLIST */
};

