#pragma interface
#include <fviews.h>

class SERVER: public ARRAY_OBJ {
public:
				// Multidrop
	SSTRINGS localdomains;	// Domains which are considered local
	SSTRING envelope;	// Envelope address header
	SSTRING qvirtual;	// Name prefix to strip
	char dns;		// 0: Enable multidrop DNS lookup
				// 1: Comparison by IP address
				// 2: DNS disabled
	SSTRINGS aka;		// DNS aliases
	bool new_server;	//
public:
				// Security
	char authenticate;	// 0: Password
				// 1: Kerberos
	SSTRING interface;	// Interfaces to monitor
	SSTRING monitor;	// Address to monitor
	SSTRING mask;		// interface mask
public:
	char poll;		// If server is active or not
	SSTRING server_name;	// Mail server name
	SSTRING protocol;	// Protocol
	/*~PROTOBEG~ SERVER */
public:
	SERVER (const char *_server_name);
	SERVER (void);
	int edit (void);
private:
	void init (void);
public:
	bool input_error (void);
	int write (int button);
	void write_item (FILE_CFG *fout,
		 const VIEWITEMS&items,
		 VIEWITEM *item,
		 bool comments_only);
	int write_server (FILE_CFG *fout);
	/*~PROTOEND~ SERVER */
};

class SERVERLIST: public ARRAY {
private:
	/*~PROTOBEG~ SERVERLIST */
public:
	SERVERLIST (void);
	int edit (void);
	SERVER *getitem (const char *server_name)const;
	SERVER *getitem (int no)const;
	void read (void);
	SERVER *select (void);
	/*~PROTOEND~ SERVERLIST */
};

