#pragma interface
#ifndef ALIAS_H
#define ALIAS_H

#ifndef MISC_H
	#include <misc.h>
#endif

class ALIASES;

class ALIAS: public ARRAY_OBJ{
public:
	SSTRING name;
	SSTRINGS values;
	SSTRING comment;
	SSTRING filter;
	SSTRING file;
	/*~PROTOBEG~ ALIAS */
public:
	ALIAS (const char *line);
	ALIAS (void);
	void addoneval (const char *val);
	int edit (PRIVILEGE *privi, ALIASES&aliases);
	int file_ok (void);
	int filter_ok (void);
	const char *getname (void);
	int is_valid (void);
	void removesome (const char *vals[], int nb);
private:
	void splitline (char *ptpt);
public:
	void write (FILE_CFG *fout);
	/*~PROTOEND~ ALIAS */
};


class ALIASES: public ARRAY{
	CONFIG_FILE &f;
	PRIVILEGE *privi;
	bool dodb;
	/*~PROTOBEG~ ALIASES */
public:
	ALIASES (CONFIG_FILE&_f,
		 PRIVILEGE *_privi,
		 bool _dodb);
private:
	void addline (SSTRING&buf);
public:
	void addnew (void);
	int edit (const char *title);
	ALIAS *getitem (int no);
	bool isdup (ALIAS *ali);
	int locate (const char *name);
	int setalias (const char *name,
		 int nb,
		 const char *vals[]);
	int unsetalias (const char *name,
		 int nb,
		 const char *vals[]);
	int write (void);
	/*~PROTOEND~ ALIASES */
};


#endif

