#ifndef NETCONF_DEF_H
#define NETCONF_DEF_H

#define LEN_IP_ASC		16		// size for an IP number in ascii

#define NETLOG_REQ		1		// Required output to netconf.log
#define NETLOG_ERR		2		// Error messages from the commands
#define NETLOG_OUT		4		// Stdout from the commands
#define NETLOG_VERB		8		// Informative stuff produced by linuxconf
#define NETLOG_CMD		16		// Command line or action
#define NETLOG_TITLE	32		// Group title
#define NETLOG_SECTION	64		// Section title
#define NETLOG_DONTDO	128		// Things which won't be done
#define NETLOG_WHY		256		// Why linuxconf is doing something

#define NETINTRO_PREBOOTING	0
#define NETINTRO_BOOTING	1
#define NETINTRO_FIXPERM	2
#define NETINTRO_UPDATE		3
#define NETINTRO_RUNLEVEL	4
#define NETINTRO_PPPPOST	5
#define NETINTRO_PPPDIALD	6
#define NETINTRO_ARCHIVE	7
#define NETINTRO_EXTRACT	8
#define NETINTRO_SWITCHCONF	9
#define NETINTRO_PUBLISH	10
#define NETINTRO_IMPORT		11
#define NETINTRO_CREATEUSER	12
#define NETINTRO_DELETEUSER	13
#define NETINTRO_MODIFYUSER	14
#define NETINTRO_SERVICES	15
#define NETINTRO_MISC		16

#endif
